#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Lime

//---- input parameters 
extern int       period=15;
extern int       method=3;                        
extern int       price=0;        
//---- buffers 
double ExtMapBuffer1[];
double vect[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init()
  {
   IndicatorBuffers(2);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);

   
   SetIndexBuffer(1, vect);


   IndicatorShortName("Signal Line("+period+")");
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit()
  { 
   return(0);
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double WMA(int x, int p)
  {
   return(iMA(NULL, 0, p, 0, method, price, x));
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0)
      return(-1);
//----
   int x=0;
   int p=MathSqrt(period);
   int e=Bars - counted_bars + period + 1;
   if(e > Bars) e=Bars;
//----
   for(x=0; x < e; x++) vect[x]=2*WMA(x, period/2) - WMA(x, period);

   for(x=0; x < e-period; x++) ExtMapBuffer1[x]=iMAOnArray(vect, 0, p, 0, method, x);
   return(0);
  }
//+------------------------------------------------------------------+ 